<?php

class MageBinary_BinaryPay_Block_Adminhtml_Customer_Edit_Tab_Creditcards extends Mage_Adminhtml_Block_Widget_Form
{
    public function __construct()
    {
        parent::__construct();
        $this->setTemplate('magebinary/binarypay/directpost/cards.phtml');
    }

    /**
     * Preparing layout
     */
    protected function _prepareLayout()
    {
        $this->setChild(
            'add_card_button',
            $this->getLayout()->createBlock('adminhtml/widget_button')
                ->setData(
                    array(
                        'label'         => Mage::helper('customer')->__('Add New Card'),
                        'id'            => 'paymark_add_card_button',
                        'name'          => 'paymark_add_card_button',
                        'element_name'  => 'add_card_button',
                        'disabled'      => $this->isReadonly(),
                        'class'         => 'add'.($this->isReadonly() ? ' disabled' : ''),
                        'onclick'       => 'addNewCard()'
                    )
                )
        );
        return parent::_prepareLayout();
    }

    /**
     * check if it readonly
     * @return boolean
     */
    public function isReadonly()
    {
        $customer = Mage::registry('current_customer');
        return $customer->isReadonly();
    }

    /**
     * get the url for delect card saved token
     * @param  array $tokenReference
     * @return string
     */
    public function getDeleteUrl($tokenReference)
    {
        $customer = Mage::registry('current_customer');
        $url = $this->getUrl('*/*/deletecard/token_reference/' . $tokenReference . "/id/" . $customer->getId());
        return $url;
    }

    /**
     * get url for adding credit card
     * @return string url
     */
    public function getAddUrl()
    {
        $customer = Mage::registry('current_customer');
        $url = $this->getUrl('*/*/addcard/id/' . $customer->getId());
        return $url;
    }
}
