<?php

class MageBinary_BinaryPay_Block_Adminhtml_Customer_Edit_Tab_Mobiles extends Mage_Adminhtml_Block_Widget_Form
{
    public function __construct()
    {
        parent::__construct();
        $this->setTemplate('magebinary/binarypay/onlineeftpos/mobiles.phtml');
    }

    /**
     * Preparing layout
     */
    protected function _prepareLayout()
    {
        $this->setChild(
            'add_mobile_button',
            $this->getLayout()->createBlock('adminhtml/widget_button')
                ->setData(
                    array(
                    'label'         => Mage::helper('customer')->__('Add New Mobile'),
                    'id'            => 'paymark_add_mobile_button',
                    'name'          => 'paymark_add_mobile_button',
                    'element_name'  => 'add_mobile_button',
                    'disabled'      => $this->isReadonly(),
                    'class'         => 'add'  . ($this->isReadonly() ? ' disabled' : ''),
                    'onclick'       => 'addInfo()'
                    )
                )
        );
        return parent::_prepareLayout();
    }

    /**
     * check if it readonly
     * @return boolean
     */
    protected function isReadonly()
    {
        $customer = Mage::registry('current_customer');
        return $customer->isReadonly();
    }

    public function getDeleteTokenUrl($tokenreference)
    {
        $customer = Mage::registry('current_customer');
        $url = $this->getUrl(
            "adminhtml/mobiles/deleteTk/",
            array (
                "id"                => $customer->getId(),
                "token_reference"   => $tokenreference
            )
        );
        return $url;
    }

    /**
     * get url for adding credit card
     * @return string url
     */
    public function getAddTokenUrl()
    {
        $customer   = Mage::registry('current_customer');
        $actionUrl  = $this->getUrl(
            'adminhtml/mobiles/addTk',
            array(
                'id' => $customer->getId()
            )
        );
        return $actionUrl;
    }
}
