<?php
/**
* Magento BinaryPay Payment Extension
*
* NOTICE OF LICENSE
*
* Copyright 2017 MageBinary
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*
* @category    MageBinary
* @package     MageBinary_BinaryPay
* @author      MageBinary Team
* @copyright   Copyright (c) 2017 MageBinary (http://www.magebinary.com)
* @license     http://www.apache.org/licenses/LICENSE-2.0
*/
include_once ('Mage/Adminhtml/controllers/CustomerController.php');
/**
 * Abstract BinaryPay Controller
 */
abstract class MageBinary_BinaryPay_Controller_Adminhtml_Abstract extends Mage_Adminhtml_CustomerController
{
    /**
     * $_code - current api name
     * @var string
     */
    protected $_code;

    /**
     * $_api - container to save Model Object
     * @var Object
     */
    protected $_api;

    protected function _getApi()
    {
        if (empty($this->_api)) {
            $this->_api = Mage::getModel('magebinary_binarypay/'. $this->_code);
        }
        return $this->_api;
    }

    protected function _getTokenReference()
    {
        $tokenReference = $this->getRequest()->getParam('token_reference');

        if (empty($tokenReference)) {
            //get tokenrefernce by post
            $postData = $this->getRequest()->getPost();
            $tokenReference = $postData['token_reference'];
        }

        //if tokenReference still empty
        if (empty($tokenReference)) {
            $message = $this->__('No token reference number value to be found.');
            Mage::throwException($message);
        }

        return $tokenReference;
    }

    /**
     * _sendMessage - send message to user in frontend
     * @param  array $message
     * @return $this
     */
    protected function _sendMessage($message)
    {
        $response = $this->getResponse();
        $response->clearHeaders()->setHeader('Content-type', 'application/json', true);
        $response->setBody(json_encode($message));
        return $this;
    }
}