<?php
class MageBinary_BinaryPay_Model_Backend_Savedtokens extends Mage_Eav_Model_Entity_Attribute_Backend_Array
{
    const TOKEN_ATTRIBUTE = 'pm_saved_tokens';
    /**
     * Serialize array in saved_tokens field, then encrypt it and save it into saved_tokens_json attribute
     *
     * @param Varien_Object $object
     * @return $this|Mage_Eav_Model_Entity_Attribute_Backend_Array
     */
    public function beforeSave($object)
    {
        $attrCode    = $this->getAttribute()->getAttributeCode();

        if ($attrCode == self::TOKEN_ATTRIBUTE) {
            $helper      = Mage::helper('core');
            $savedTokens = $object->getData($attrCode);

            if (is_array($savedTokens)) {
                $object->setData($attrCode, $helper->encrypt($helper->jsonEncode($savedTokens)));
            }
        }

        return parent::beforeSave($object);
    }

    /**
     * Decrypt data in saved_tokens_json, decode it into array and set into saved_tokens field.
     *
     * @param Varien_Object $object
     * @return $this|Mage_Eav_Model_Entity_Attribute_Backend_Array
     */
    public function afterLoad($object)
    {
        $attrCode = $this->getAttribute()->getAttributeCode();

        if ($attrCode == self::TOKEN_ATTRIBUTE) {
            $helper = Mage::helper('core');
            $tokens = $object->getData($attrCode);

            if (!empty($tokens)) {
                $object->setData(self::TOKEN_ATTRIBUTE, $helper->jsonDecode($helper->decrypt($tokens)));
            }
        }

        return parent::afterLoad($object);
    }
}