<?php
/**
* Magento BinaryPay Payment Extension
*
* NOTICE OF LICENSE
*
* Copyright 2017 MageBinary
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*
* @category    MageBinary
* @package     MageBinary_BinaryPay
* @author      MageBinary Team
* @copyright   Copyright (c) 2017 MageBinary (http://www.magebinary.com)
* @license     http://www.apache.org/licenses/LICENSE-2.0
*/
class MageBinary_BinaryPay_Model_Onlineeftpos extends MageBinary_BinaryPay_Model_Abstract
{
    protected $_code    = MageBinary_BinaryPay_Model_Config::PAYMARK_ONLINEEFTPOS;

    public function saveToken($data)
    {
        $dataInfo   = new Varien_Object();
        /* Throw this to the lib */
        $dataKeys   = array('mobile_number', 'token_reference');

        foreach ($dataKeys as $key) {
            if (isset($data[$key])) {
                $dataInfo->setData($key, $data[$key]);
            }
        }

        parent::saveToken($dataInfo);
    }

    public function getCustomerMobiles()
    {
        $customer   = $this->getCustomer();
        $collection = new Varien_Data_Collection();
        $tokens     = $customer->getPmSavedTokens();
        $data       = array();

        if (!empty($tokens)) {
            foreach ($tokens as $token) {
                if (isset($token['mobile_number'])) {
                    $item = new Varien_Object;
                    $item->addData($token);
                    $collection->addItem($item);
                }
            }
        }
        return $collection;
    }

    public function generateTokenReference($mobile)
    {
        return empty($mobile) ? false : md5(Mage::helper('core')->encrypt($mobile));
    }
}