<?php
/**
* Magento BinaryPay Payment Extension
*
* NOTICE OF LICENSE
*
* Copyright 2017 MageBinary
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*
* @category    MageBinary
* @package     MageBinary_BinaryPay
* @author      MageBinary Team
* @copyright   Copyright (c) 2017 MageBinary (http://www.magebinary.com)
* @license     http://www.apache.org/licenses/LICENSE-2.0
*/
class MageBinary_BinaryPay_Model_System_General
{
    const CARD_TYPE_MASTERCARD = 'MC';
    const CARD_TYPE_VISA       = 'VISA';
    const CARD_TYPE_DINERS     = 'DI';
    const CARD_TYPE_DINERS_CLUB= 'DINERS_CLUB';
    const CARD_TYPE_AMEX       = 'AMEX';
    const CARD_TYPE_AMERICAN_EXPRESS  = 'AMERICAN_EXPRESS';
    const CARD_TYPE_QCARD      = 'QCARD';
    const CARD_VISA            = 'Visa';
    const CARD_MASTERCARD      = 'MasterCard';
    const CARD_AMEX            = 'American Express';
    const CARD_DINERS          = 'Diners Club';
    const CARD_QCARD           = 'QCard';

    /**
     * get card logo url from card type
     * @param  string $cardType
     * @return string
     */
    public function getCardLogoFileNameByCardType($cardType)
    {
        return $cardType . '.png';
    }

}