<?php
/**
* Magento BinaryPay Payment Extension
*
* NOTICE OF LICENSE
*
* Copyright 2017 MageBinary
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*   http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*
* @category    MageBinary
* @package     MageBinary_BinaryPay
* @author      MageBinary Team
* @copyright   Copyright (c) 2017 MageBinary (http://www.magebinary.com)
* @license     http://www.apache.org/licenses/LICENSE-2.0
*/
class MageBinary_BinaryPay_Model_System_Term
{
    // const FLEXI_SIX_MONTH = '6_MTHS';
    const FLEXI_SIX_MONTH = '510';
    // const FLEXI_TWL_MONTH = '12_MTHS';
    const FLEXI_TWL_MONTH = '517';
    const FLEXI_ETE_MONTH = '523';


    public function toOptionArray()
    {
        return array(
            array(
                'value' => self::FLEXI_SIX_MONTH,
                'label' => Mage::helper('magebinary_binarypay')->__('6 Months')
            ),
            array(
                'value' => self::FLEXI_TWL_MONTH,
                'label' => Mage::helper('magebinary_binarypay')->__('12 Months')
            ),
            array(
                'value' => self::FLEXI_ETE_MONTH,
                'label' => Mage::helper('magebinary_binarypay')->__('18 Months')
            )
        );
    }
}