<?php
set_include_path(get_include_path() . PATH_SEPARATOR . realpath(dirname(__FILE__)));
require_once('Http.php');


spl_autoload_register(
    function ($className) {
        $libName = 'BinaryPay';

        if ($className != $libName) {
            $file = __DIR__ . DIRECTORY_SEPARATOR . 'Gateways' . DIRECTORY_SEPARATOR . $className . '.php';
            if (is_file($file)) {
                require_once $file;
                return;
            }
        }

        if (strpos($className, $libName) !== 0) {
            return;
        }

        $fileName = __DIR__ . DIRECTORY_SEPARATOR;

        if ($lastNsPos = strripos($className, '\\')) {
            $namespace = substr($className, 0, $lastNsPos);
            $className = substr($className, $lastNsPos + 1);
            $fileName  .= str_replace('\\', DIRECTORY_SEPARATOR, $namespace) . DIRECTORY_SEPARATOR;
        }

        $fileName .= str_replace($libName.'_', DIRECTORY_SEPARATOR, $className) . '.php';
        if (is_file($fileName)) {
            require_once $fileName;
        }
    }
);
