#!/usr/bin/php
<?php
require_once 'autoload.php';

/*
@Usage & Test

How to use(Example): type ./lib/BinaryPay/test.php in the terminal

This file could be used to test all the functions in the library level. Also, the developer could use this file to test the functions with their own Paymark's credentials. You can uncomment the commented  function to process a failed purchase transaction

*/

try{
    $finance = BinaryPay::getGateway(
        'Financenow',
        array(
            // DealerName
            BinaryPay::USERNAME     => 'BinaryPay',
            // DealerNr
            BinaryPay::ACCOUNTID    => '2000000',
            // DealerEmail
            BinaryPay::PASSWORD     => 'david@magebinary.com',
            BinaryPay::ENVIRONMENT  => 'development',
        )
    );
    echo "Financenow: Get Financenow Insatance\n";

    $purchase = $finance->purchase(
        array(
            // Conatct
            BinaryPay::REFERENCE        => 'transaction reference',
            // Product
            BinaryPay::PARTICULAR       => 'transaction particular',
            BinaryPay::AMOUNT           => 2495.00,
            BinaryPay::TERM             => '30',
            BinaryPay::DEFTERM          => '0',
            BinaryPay::DEPOSIT          => 250.00,
            BinaryPay::RATE             => 16.75,
            BinaryPay::CUSTOMER_NAME    => 'CUSTOMER001',
            BinaryPay::CUSTOMER_EMAIL   => 'test@test.com'
        )
    );

    echo $purchase. "\n";

    echo "Finance: Redirect to payment page\n";

    die();
    $qcard = BinaryPay::getGateway(
        'Flexilong',
        array(
            // This is Qcard's login id
            BinaryPay::USERNAME        => '203399',
            // This is Qcard's password
            BinaryPay::PASSWORD        => 'Password01',
            // This is Qcard's merchant id
            BinaryPay::ACCOUNTID       => '12321',
            BinaryPay::ENVIRONMENT     => 'development',
        )
    );
    echo "Qcard: Get Qcard Insatance\n";

    $payment = $qcard->purchase(
        array(
            // This is Qcard's API Key
            BinaryPay::API_KEY          => '2bef9740cd0be5995e58f9eef3249cabbd65d4bc',
            BinaryPay::REFERENCE        => '123',
            BinaryPay::AMOUNT           => 10000,
            BinaryPay::PRODUCT_CODE     => "6_MTHS",
            BinaryPay::RETURN_URL       => "http://sandbox.api.binarypay.dev",
            BinaryPay::REDIRECT         => false,
            BinaryPay::SKU              => '1000001',
            BinaryPay::DESCRIPTION      => 'XXXXX',
            BinaryPay::QUANTITY         => 1,
        )
    );

    echo "Qcard: Successful purchase\n";

    $transactionDetail = $qcard->getTransaction(
        array(
            BinaryPay::API_KEY          => '2bef9740cd0be5995e58f9eef3249cabbd65d4bc',
            BinaryPay::TRANSACTION_ID   => $payment['merchant_transaction_id'],
            BinaryPay::PROCESS_NO       => $payment['process_no'],
        )
    );

    print_r($transactionDetail);

    echo "Qcard: Retrieved transaction information\n";

    $directPost = BinaryPay::getGateway(
        'Directpost',
        array(
            // This is Paymark's Username
            BinaryPay::USERNAME        => '101538',
            // This is Paymark's Password
            BinaryPay::PASSWORD        => 'jddei73h',
            // This is Paymark's AccountId
            BinaryPay::ACCOUNTID       => '621620',
            BinaryPay::ENVIRONMENT     => 'sandbox',
            // This is Api Key
            BinaryPay::API_KEY         => 'ace793175916061c16741ac6853ca570',
        )
    );

    echo "DirectPost: Get DirectPost Insatance\n";

    /*
    @Usage - Process a successful transaction by purchase
     */

    $transaction = $directPost->purchase(
        array(
            BinaryPay::ACCOUNTID     => '621620',
            BinaryPay::AMOUNT        => '1022.00',
            BinaryPay::CARD_NUMBER   => '4111111111111111',
            BinaryPay::CARD_TYPE     => 'VISA',
            BinaryPay::CARD_EXPIRY   => '1220',
            BinaryPay::CARD_HOLDER   => 'John Smith',
            BinaryPay::CARD_CSC      => '111',
            BinaryPay::EMAIL         => '',
            BinaryPay::PARTICULAR    => 'transaction particular',
            BinaryPay::REFERENCE     => 'transaction reference',
            BinaryPay::CARD_TOKEN_REF=> 'TokenReference',
            BinaryPay::STORE_CARD    => 0
        )
    );

    echo "DirectPost: Successful purchase\n";

    /*
    @Usage - Process a successful transaction and save used card by purchase
     */

    $directPost->purchase(
        array(
            BinaryPay::ACCOUNTID     => '621620',
            BinaryPay::AMOUNT        => '1022.00',
            BinaryPay::CARD_NUMBER   => '4111111111111111',
            BinaryPay::CARD_TYPE     => 'VISA',
            BinaryPay::CARD_EXPIRY   => '1220',
            BinaryPay::CARD_HOLDER   => 'John Smith',
            BinaryPay::CARD_CSC      => '111',
            BinaryPay::EMAIL         => '',
            BinaryPay::PARTICULAR    => 'transaction particular',
            BinaryPay::REFERENCE     => 'transaction reference',
            BinaryPay::CARD_TOKEN_REF=> 'TokenReference',
            BinaryPay::STORE_CARD    => 1
        )
    );

    echo "DirectPost: Successful purchase and saved card\n";

    /*
    @Usage - Process a declined transaction by purchase
     */

    // $directPost->purchase(
    //     array(
    //         BinaryPay::CARD_NUMBER   => '4929474753922860',
    //         BinaryPay::CARD_TYPE     => 'VISA',
    //         BinaryPay::CARD_EXPIRY   => '1220',
    //         BinaryPay::CARD_HOLDER   => 'John Smith',
    //         BinaryPay::CARD_CSC      => '111',
    //         BinaryPay::STORE_CARD    => 1
    //     )
    // );


    /*
    @Usage - process a purchase by token
     */

    $directPost->purchase(
        array(
            BinaryPay::ACCOUNTID    => '621620',
            BinaryPay::AMOUNT       => '100',
            BinaryPay::REFERENCE    => "TestReference1339",
            BinaryPay::PARTICULAR   => "TestPartixxxxcular",
            BinaryPay::EMAIL        => "",
            BinaryPay::CARD_TOKEN   => "176716546843"
        )
    );

    echo "DirectPost: Purchased by token\n";

    /*
    @Usage - Save card to Paymark Api
     */

    $added = $directPost->add(
        array(
            BinaryPay::CARD_NUMBER     => "4111111111111111",
            BinaryPay::CARD_TYPE       => "VISA",
            BinaryPay::CARD_EXPIRY     => "1220",
            BinaryPay::CARD_HOLDER     => "Test XX",
            BinaryPay::CARD_TOKEN_REF  => "123123123",
        )
    );

    echo "DirectPost: Successful saved card token\n";

    /*
    @Usage - Retrieve card information by card token
     */
    $directPost->retrieve(
        array(
            BinaryPay::CARD_TOKEN => $added['cardToken']
        )
    );

    echo "DirectPost: Get card information by card token\n";

    /*
    @Usage - Update card information by card token
     */
    $directPost->update(
        array(
            BinaryPay::CARD_TOKEN => $added['cardToken']
        )
    );

    echo "DirectPost: Updated saved card information\n";

    /*
    @Usage - Refund purchase
     */
    $directPost->refund(
        array(
            BinaryPay::TRANSACTION_ID => $transaction['transactionId'],
            BinaryPay::AMOUNT         => $transaction['amount'],
            BinaryPay::REFERENCE      => "transaction reference",
            BinaryPay::PARTICULAR     => "transaction particular",
            BinaryPay::EMAIL          => ""
        )
    );

    echo "DirectPost: Process a successful refund transaction\n";

    /*
    @Usage - Get Transaction details by transaction id
     */
    $directPost->getTransaction($transaction['transactionId']);

    echo "DirectPost: Get transaction information by transaction id\n";

    /*
    @Usage - Delete card from Paymark Api
     */
    $directPost->delete(
        array(
            BinaryPay::CARD_TOKEN => $added['cardToken']
        )
    );

    echo "DirectPost: Delete a saved card from Paymark\n";

    $webPayment = BinaryPay::getGateway(
        'Webpayment',
        array(
            // This is Paymark's Username
            BinaryPay::USERNAME        => '101538',
            // This is Paymark's Password
            BinaryPay::PASSWORD        => 'jddei73h',
            // This is Paymark's AccountId
            BinaryPay::ACCOUNTID       => '621620',
            BinaryPay::ENVIRONMENT     => 'sandbox',
            // This is Api Key
            BinaryPay::API_KEY         => 'ace793175916061c16741ac6853ca570',
        )
    );

    echo "WebPayment: Get WebPayment Insatance\n";

    /*
    @Usage - Process a transaction by purchase
     */
    $webPayment->purchase(
        array(
            BinaryPay::ACCOUNTID     => '621620',
            BinaryPay::AMOUNT        => '111',
            BinaryPay::REFERENCE     => 'TestReference1339',
            BinaryPay::PARTICULAR    => 'TestParticular2',
            // The Url that will be posted to, after the purchase
            BinaryPay::RETURN_URL    => 'http://magento.david.dev/paymark/tokens/return',
            BinaryPay::STORE_CARD    => '1',
            BinaryPay::DISPLAY_EMAIL => '0'
        )
    );

    echo "WebPayment: Get the Payment Url\n";

    /*
    @Usage - Save card to Paymark Api
     */

    $added = $webPayment->add(
        array(
            BinaryPay::CARD_NUMBER     => "4111111111111111",
            BinaryPay::CARD_TYPE       => "VISA",
            BinaryPay::CARD_EXPIRY     => "1220",
            BinaryPay::CARD_HOLDER     => "Test XX",
            BinaryPay::CARD_TOKEN_REF  => "123123123",
        )
    );

    echo "WebPayment: Save Card to Paymark\n";

    /*
    @Usage - Retrive card information by card token
     */
    $webPayment->retrieve(
        array(
            BinaryPay::CARD_TOKEN => $added['cardToken']
        )
    );

    echo "WebPayment: Retrive card information by card token\n";

    /*
    @Usage - Update card information by card token
     */
    $webPayment->update(
        array(
            BinaryPay::CARD_TOKEN => $added['cardToken']
        )
    );

    echo "WebPayment: Update card information by card token\n";

    /*
    @Usage - Refund purchase
     */
    $webPayment->refund(
        array(
            BinaryPay::TRANSACTION_ID => 'P170310002307806',
            BinaryPay::AMOUNT         => '1',
            BinaryPay::REFERENCE      => "transaction reference",
            BinaryPay::PARTICULAR     => "transaction particular",
            BinaryPay::EMAIL          => ""
        )
    );

    echo "WebPayment: Process a successful refund\n";

    /*
    @Usage - Get Transaction details by transaction id
     */
    $webPayment->getTransaction($transaction['transactionId']);

    echo "WebPayment: Get Transaction details by transaction id\n";

    /*
    @Usage - Delete card from Paymark Api
     */
    $webPayment->delete(
        array(
            BinaryPay::CARD_TOKEN => $added['cardToken']
        )
    );

    echo "WebPayment: Delete saved card from Paymark\n";

    $OEPayment = BinaryPay::getGateway(
        'Onlineeftpos',
        array(
            // This is the Username for Paymark As Consumer Key
            BinaryPay::USERNAME      => 'JPGrtXDFnIhOm9NUSsSLJS0m7iLIzPlh',
            // This is the password for Paymark As Consumer Secret
            BinaryPay::PASSWORD      => 'ST3aM183DRtonhTT',
            // This is the accountId for Paymark As Merchant Id
            BinaryPay::ACCOUNTID     => '300000005',
            BinaryPay::ENVIRONMENT   => 'sandbox',
            // This is Api Key
            BinaryPay::API_KEY       => 'ace793175916061c16741ac6853ca570',
        )
    );

    echo "OnlineEFTPOS: Get OnlineEFTPOS Insatance\n";

    /*
    @Usage - Process a successful transaction by purchase
     */
    $purchase = $OEPayment->purchase(
        array(
            BinaryPay::MOBILENUMBER  => '0210123456',
            BinaryPay::PAYMENT_TYPE  => "MOBILE",
            BinaryPay::BANK_ID       => "ASB",
            BinaryPay::ACCOUNTID     => "300000005",
            BinaryPay::RETURN_URL    => "http://dev.magebinary.com:7788/paymark/return/key/70141ae5179df443033a2f89523b1755",
            BinaryPay::MERCHANT_URL  => "http://dev.magebinary.com",
            BinaryPay::AMOUNT        => 10000,
            BinaryPay::CURRENCY      => "NZD",
            BinaryPay::DESCRIPTION   => "",
            BinaryPay::REFERENCE     => "199",
            BinaryPay::USER_AGENT    => "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 Safari/537.36",
            BinaryPay::IP            => "192.168.0.1"
        )
    );

    echo "OnlineEFTPOS: Process a successful purchase transaction\n";

    /*
    @Usage - Process a failed transaction by purchase
     */
    // $OEPayment->purchase(
    //     array(
    //         BinaryPay::MOBILENUMBER  => '0210123456',
    //         BinaryPay::PAYMENT_TYPE  => "MOBILE",
    //         BinaryPay::BANK_ID       => "ASB",
    //         BinaryPay::ACCOUNTID     => "300000005",
    //         BinaryPay::RETURN_URL    => "http://dev.magebinary.com:7788/paymark/retkey/70141ae5179df443033a2f89523b1755",
    //         BinaryPay::MERCHANT_URL  => "http://dev.magebinary.com",
    //         BinaryPay::AMOUNT        => 1.17,
    //         BinaryPay::CURRENCY      => "NZD",
    //         BinaryPay::DESCRIPTION   => "",
    //         BinaryPay::REFERENCE     => "199",
    //         BinaryPay::USER_AGENT    => "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 Safari/537.36",
    //         BinaryPay::IP            => "192.168.0.1"
    //     )
    // );


    /*
    @Usage - Process a refund transaction
     */
    $refund = $OEPayment->refund(
        array(
            BinaryPay::MOBILENUMBER      => '0210123456',
            BinaryPay::PAYMENT_TYPE      => "MOBILE",
            BinaryPay::BANK_ID           => "ASB",
            BinaryPay::ACCOUNTID         => "300000005",
            BinaryPay::AMOUNT            => 0.1,
            BinaryPay::DESCRIPTION       => 'Defective goods',
            BinaryPay::REFUND_ID         => '145',
            BinaryPay::ORIGIN_TRANSACTION_ID => 'e0f72f84-4772-4527-a937-45d33cd0ec8d',
            BinaryPay::USER_AGENT        => "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_2) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/47.0.2526.106 Safari/537.36",
            BinaryPay::IP                => "192.168.0.1"
        )
    );

    echo "OnlineEFTPOS: process a successful refund transaction\n";

    /*
    @Usage - Get Transaction details by transaction Id
     */
    $OEPayment->getTransaction($purchase['id']);

    echo "OnlineEFTPOS: Get purchase transaction details by transaction id\n";

    /*
    @Usage - Get refund Transaction details by transaction Id
     */
    $OEPayment->getTransaction($refund['id'], true);

    echo "OnlineEFTPOS: Get refund transaction detail by transaction id\n";

} catch (Exception $e) {
    var_dump($e->getMessage());
}